#pragma once

#include <cstddef>
#include <exception>

template<typename T>
class Array
{
    private:
        T* _arr;
        unsigned int _size;
    
    public:
        Array():
            _arr(new T[0]),
            _size(0)
        {};
        Array(unsigned int n):
            _arr(new T[n]),
            _size(n)
        {};
        Array(const Array& src)
        {
            new T[0];
            *this = src;
        };

        ~Array()
        {
            delete[] this->_arr;
        };

        Array& operator=(const Array& src)\
        {
            if (this == &src)
                return ;
            delete[] this->_arr;
            this->_size = src._size;
            new T[src._size];
            for (size_t i = 0; i < src._size; i++)
                this->_arr[i] = src._arr[i];
        };
        Array& operator[](unsigned int index)
        {
            if (index >= _size)
				throw std::exception();
			return _arr[index];
        };

        unsigned int size() const
        {
        	return _size;
        };
};
